﻿package
{
	import flash.display.Sprite; 
	import flash.utils.setInterval;
	import flash.events.Event;
	import flash.display.DisplayObject;
	import src.MyCamera;
	import flash.geom.Rectangle;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;

	public class Trainer extends Sprite
	{
		private var myCam:MyCamera;
		private var recorder:BitmapData;
		private var bmpData:BitmapData;
		private var container:Sprite = new Sprite;
		public static var sw:Object = {x:0,y:0,width:20};
		private var filterObj:BlurFilter = new BlurFilter(2,2,1);
		
		public function Trainer()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);	
		}
		private function addedHandler(e:Event):void
		{
			myCam = new MyCamera ("computer","",stage.stageWidth,stage.stageHeight,true);
			bmpData = new BitmapData(stage.stageWidth,stage.stageHeight,true,0);
			addChild(new Bitmap(bmpData)) as Bitmap;
			
			setInterval(addStraw,50);
			stage.addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function addStraw():void
		{
			//recorder.draw(myCam);
			recorder = new BitmapData (myCam.width,myCam.height, true, 0);
			recorder.draw(myCam,null,null,null, new Rectangle(mouseX-sw.width/2,0,sw.width,stage.stageHeight));
			
			var straw:Straw = new Straw(stage.stageHeight,recorder,mouseX);
			straw.x = mouseX;
			container.addChild(straw);
			if (container.numChildren > 20) container.removeChildAt(0);
		}
		private function enterHandler (event:Event){
			if (container.numChildren > 0){
				for (var i=0;i<container.numChildren;i++){
					var o:Object = container.getChildAt(i);
					o.changeStraw();
				}
			}
			bmpData.draw(container,new Matrix(1,0,0,1,0,0));
			bmpData.applyFilter(bmpData,bmpData.rect,new Point(0,0),filterObj);
		}
	}
}
import flash.display.Sprite;
import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.PixelSnapping;

internal class Straw extends Sprite
{
	var _height:Number;
	public function Straw(height:Number,image:BitmapData,xdep:Number):void
	{
		var croppedBitmap:Bitmap = new Bitmap(image, PixelSnapping.ALWAYS, true);
		croppedBitmap.x = - xdep;
		addChild(croppedBitmap);
	}
	public function changeStraw():void
	{
		/*
		if(this.x <= parent.mouseX+30 && this.x >= parent.mouseX-30){
			var f:Number = parent.mouseX-this.x;
			var c:Number = parent.mouseY-this.y;
			var alpha:Number = Math.asin(f/Math.sqrt(f*f + c*c))*180/Math.PI;
			if(Math.sqrt(f*f + c*c)>=_height){
				(this.rotation<0)?this.rotation+=0.1:this.rotation=0;
			}else{
				this.rotation = -alpha;
			}
		}
		
		if(this.x <= 0){
			parent.removeChild(this);
		}else{
			this.x-=3;
		}
		*/
		this.y -= 3;
	}
}